automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

FYI: fix for PR/359 (check: $(BUILT_SOURCES))


From: Alexandre Duret-Lutz
Subject: FYI: fix for PR/359 (check: $(BUILT_SOURCES))
Date: Fri, 29 Nov 2002 22:50:58 +0100
User-agent: Gnus/5.090008 (Oort Gnus v0.08) Emacs/20.7 (i386-debian-linux-gnu)

I'm checking this in (HEAD & branch-1-7).
This fixes `check' to depend on BUILT_SOURCES (when defined).

2002-11-29  Alexandre Duret-Lutz  <address@hidden>

        For PR automake/359:
        * automake.in (do_check_merge_target): Make `check' dependent on
        $(BUILT_SOURCES) if the variable is defined.  Run `check-am' or
        `check-recursive' in a submake in this case.
        * tests/check2.test, tests/check3.test: New files.
        * tests/check.test: Make sure `check' depends on `check-am'.
        * tests/Makefile.am (TESTS): Add check2.test and check3.test.

Index: automake.in
===================================================================
RCS file: /cvs/automake/automake/automake.in,v
retrieving revision 1.1365.2.13
diff -u -r1.1365.2.13 automake.in
--- automake.in 29 Nov 2002 17:53:02 -0000      1.1365.2.13
+++ automake.in 29 Nov 2002 21:49:51 -0000
@@ -4861,7 +4861,11 @@
        if @check_tests;
 
     &depend ('.PHONY', 'check', 'check-am');
+    # Handle recursion.  We have to honor BUILT_SOURCES like for `all:'.
     $output_rules .= ("check: "
+                     . (variable_defined ('BUILT_SOURCES')
+                        ? "\$(BUILT_SOURCES)\n\t\$(MAKE) \$(AM_MAKEFLAGS)"
+                        : '')
                      . (variable_defined ('SUBDIRS')
                         ? 'check-recursive' : 'check-am')
                      . "\n");
Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.443.2.7
diff -u -r1.443.2.7 Makefile.am
--- tests/Makefile.am   29 Nov 2002 17:53:03 -0000      1.443.2.7
+++ tests/Makefile.am   29 Nov 2002 21:49:53 -0000
@@ -49,6 +49,8 @@
 canon5.test \
 ccnoco.test \
 check.test \
+check2.test \
+check3.test \
 checkall.test \
 clean.test \
 colneq.test \
Index: tests/check.test
===================================================================
RCS file: /cvs/automake/automake/tests/check.test,v
retrieving revision 1.3
diff -u -r1.3 check.test
--- tests/check.test    8 Sep 2002 13:07:55 -0000       1.3
+++ tests/check.test    29 Nov 2002 21:49:54 -0000
@@ -22,19 +22,23 @@
 
 . ./defs || exit 1
 
+set -e
+
 cat > Makefile.am << 'END'
 TESTS = frob.test
 END
 
 : > frob.test
 
-$ACLOCAL || exit 1
-$AUTOMAKE || exit 1
+$ACLOCAL
+$AUTOMAKE
 
-grep '^check-TESTS:' Makefile.in || exit 1
+grep '^check-TESTS:' Makefile.in
 grep '^check-DEJAGNU' Makefile.in && exit 1
 
 # check-TESTS is phony.
-sed -n '/^\.PHONY:/,/^$/p' Makefile.in | grep check-TESTS || exit 1
+sed -n '/^\.PHONY:/,/^$/p' Makefile.in | grep check-TESTS
 
-exit 0
+# check should depend directly on check-am (similar tests are
+# in check2.test and check3.test).
+grep '^check: check-am' Makefile.in
Index: tests/check2.test
===================================================================
RCS file: tests/check2.test
diff -N tests/check2.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/check2.test   29 Nov 2002 21:49:54 -0000
@@ -0,0 +1,62 @@
+#! /bin/sh
+# Copyright (C) 2002  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with autoconf; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Test Automake style tests.
+
+. ./defs || exit 1
+
+set -e
+
+cat >> configure.in << 'END'
+AC_CONFIG_FILES([dir/Makefile])
+AC_OUTPUT
+END
+
+mkdir dir
+
+cat > Makefile.am << 'END'
+SUBDIRS = dir
+TESTS = subrun.sh
+subrun.sh:
+       (echo '#! /bin/sh'; echo 'dir/echo.sh') > $@
+       chmod +x $@
+CLEANFILES = subrun.sh
+END
+
+cat > dir/Makefile.am << 'END'
+check_SCRIPTS = echo.sh
+echo.sh:
+       (echo '#! /bin/sh'; echo 'echo Hello') > $@
+       chmod +x $@
+CLEANFILES = echo.sh
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE
+./configure
+$MAKE check >stdout
+cat stdout
+grep 'PASS: subrun.sh' stdout
+
+# check should depend directly on check-am (similar tests are
+# in check.test and check3.test).
+grep 'check: check-recursive' Makefile.in
+grep 'check: check-am' dir/Makefile.in
Index: tests/check3.test
===================================================================
RCS file: tests/check3.test
diff -N tests/check3.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/check3.test   29 Nov 2002 21:49:54 -0000
@@ -0,0 +1,69 @@
+#! /bin/sh
+# Copyright (C) 2002  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with autoconf; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Make sure `check:' honors $(BUILT_SOURCES).
+# PR/359.
+
+. ./defs || exit 1
+
+set -e
+
+cat >> configure.in << 'END'
+AC_CONFIG_FILES([dir/Makefile])
+AC_OUTPUT
+END
+
+mkdir dir
+
+cat > Makefile.am << 'END'
+BUILT_SOURCES = command1.inc
+SUBDIRS = dir
+TESTS = subrun.sh
+subrun.sh:
+       (echo '#! /bin/sh'; cat command1.inc) > $@
+       chmod +x $@
+command1.inc:
+       echo 'dir/echo.sh' > $@
+CLEANFILES = subrun.sh command1.inc
+END
+
+cat > dir/Makefile.am << 'END'
+BUILT_SOURCES = command2.inc
+check_SCRIPTS = echo.sh
+echo.sh:
+       (echo '#! /bin/sh'; cat command2.inc) > $@
+       chmod +x $@
+command2.inc:
+       echo 'echo Hello' > $@
+CLEANFILES = echo.sh command2.inc
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE
+./configure
+$MAKE check >stdout
+cat stdout
+grep 'PASS: subrun.sh' stdout
+
+# check should depend directly on check-am (similar tests are
+# in check.test and check2.test).
+$FGREP 'check: $(BUILT_SOURCES)' Makefile.in
+$FGREP 'check: $(BUILT_SOURCES)' dir/Makefile.in

-- 
Alexandre Duret-Lutz





reply via email to

[Prev in Thread] Current Thread [Next in Thread]